# 90DaysOfDevOps

This repository is used to document my journey on getting a better foundational knowledge of DevOps. I will be starting this journey on the 1st January 2022 but the idea is that we take 90 days which just so happens to be January 1st to March 31st. 

The reason for documenting these days is so that others can take something from it and also hopefully enhance the resources. 

The goal is to take 90 days, 1 hour a day, to tackle over 13 areas of DevOps to a foundational knowledge. 

This will not cover all things DevOps but it will cover the areas that I feel will benefit my learning and understanding overall. 

## Progress 

- [ ] ♾️ 1 > [Introduction](Days/day01.md)

### What is and why do we use DevOps

- [ ] ♾️ 2 > [Responsibilities of a DevOps Engineer](Days/day02.md)
- [ ] ♾️ 3 > [DevOps Lifecycle - Application Focused](Days/day03.md)
- [ ] ♾️ 4 > [DevOps & Agile](Days/day04.md)
- [ ] ♾️ 5 > [Plan > Code > Build > Testing > Release > Deploy > Operate > Monitor >](Days/day05.md)
- [ ] ♾️ 6 > [DevOps - The real stories](Days/day06.md)

### Learning a Programming Language

- [ ] ⌨️ 7 > [The Big Picture - DevOps & Learning a Programming Language](Days/day07.md)
- [ ] ⌨️ 8 > [Setting up your DevOps environment for Go & Hello World](Days/day08.md)
- [ ] ⌨️ 9 > [Let's explain the Hello World code](Days/day09.md)
- [ ] ⌨️ 10 > [The Go Workspace & Compiling & running code](Days/day10.md)
- [ ] ⌨️ 11 > [Variables, Constants & Data Types](Days/day11.md)
- [ ] ⌨️ 12 > [Getting user input with Pointers and a finished program](Days/day12.md)
- [ ] ⌨️ 13 > [](Days/day13.md)

### Knowing Linux Basics

- [ ] 🐧 14 > [](Days/day14.md)
- [ ] 🐧 15 > [](Days/day15.md)
- [ ] 🐧 16 > [](Days/day16.md)
- [ ] 🐧 17 > [](Days/day17.md)
- [ ] 🐧 18 > [](Days/day18.md)
- [ ] 🐧 19 > [](Days/day19.md)
- [ ] 🐧 20 > [](Days/day20.md)

### Understand Networking

- [ ] 🌐 21 > [](Days/day21.md)
- [ ] 🌐 22 > [](Days/day22.md)
- [ ] 🌐 23 > [](Days/day23.md)
- [ ] 🌐 24 > [](Days/day24.md)
- [ ] 🌐 25 > [](Days/day25.md)
- [ ] 🌐 26 > [](Days/day26.md)
- [ ] 🌐 27 > [](Days/day27.md)

### Stick to one Cloud Provider

- [ ] ☁️ 28 > [](Days/day28.md)
- [ ] ☁️ 29 > [](Days/day29.md)
- [ ] ☁️ 30 > [](Days/day30.md)
- [ ] ☁️ 31 > [](Days/day31.md)
- [ ] ☁️ 32 > [](Days/day32.md)
- [ ] ☁️ 33 > [](Days/day33.md)
- [ ] ☁️ 34 > [](Days/day34.md)

### Use Git Effectively

- [ ] 📚 35 > [](Days/day35.md)
- [ ] 📚 36 > [](Days/day36.md)
- [ ] 📚 37 > [](Days/day37.md)
- [ ] 📚 38 > [](Days/day38.md)
- [ ] 📚 39 > [](Days/day39.md)
- [ ] 📚 40 > [](Days/day40.md)
- [ ] 📚 41 > [](Days/day41.md)

### Containers 

- [ ] 🏗️ 42 > [](Days/day42.md)
- [ ] 🏗️ 43 > [](Days/day43.md)
- [ ] 🏗️ 44 > [](Days/day44.md)
- [ ] 🏗️ 45 > [](Days/day45.md)
- [ ] 🏗️ 46 > [](Days/day46.md)
- [ ] 🏗️ 47 > [](Days/day47.md)
- [ ] 🏗️ 48 > [](Days/day48.md)

### Kubernetes

- [ ] ☸ 49 > [](Days/day49.md)
- [ ] ☸ 50 > [](Days/day50.md)
- [ ] ☸ 51 > [](Days/day51.md)
- [ ] ☸ 52 > [](Days/day52.md)
- [ ] ☸ 53 > [](Days/day53.md)
- [ ] ☸ 54 > [](Days/day54.md)
- [ ] ☸ 55 > [](Days/day55.md)

### Learn Infrastructure as Code

- [ ] 🤖 56 > [](Days/day56.md)
- [ ] 🤖 57 > [](Days/day57.md)
- [ ] 🤖 58 > [](Days/day58.md)
- [ ] 🤖 59 > [](Days/day59.md)
- [ ] 🤖 60 > [](Days/day60.md)
- [ ] 🤖 61 > [](Days/day61.md)
- [ ] 🤖 62 > [](Days/day62.md)

### Automate Configuration Management

- [ ] 📜 63 > [](Days/day63.md)
- [ ] 📜 64 > [](Days/day64.md)
- [ ] 📜 65 > [](Days/day65.md)
- [ ] 📜 66 > [](Days/day66.md)
- [ ] 📜 67 > [](Days/day67.md)
- [ ] 📜 68 > [](Days/day68.md)
- [ ] 📜 69 > [](Days/day69.md)

### Create CI/CD Pipelines 

- [ ] 🔄 70 > [](Days/day70.md)
- [ ] 🔄 71 > [](Days/day71.md)
- [ ] 🔄 72 > [](Days/day72.md)
- [ ] 🔄 73 > [](Days/day73.md)
- [ ] 🔄 74 > [](Days/day74.md)
- [ ] 🔄 75 > [](Days/day75.md)
- [ ] 🔄 76 > [](Days/day76.md)

### Monitoring, Log Management, and Data Visualisation

- [ ] 📈 77 > [](Days/day77.md)
- [ ] 📈 78 > [](Days/day78.md)
- [ ] 📈 79 > [](Days/day79.md)
- [ ] 📈 80 > [](Days/day80.md)
- [ ] 📈 81 > [](Days/day81.md)
- [ ] 📈 82 > [](Days/day82.md)
- [ ] 📈 83 > [](Days/day83.md)

### Store & Protect Your Data

- [ ] 🗃️ 84 > [](Days/day84.md)
- [ ] 🗃️ 85 > [](Days/day85.md)
- [ ] 🗃️ 86 > [](Days/day86.md)
- [ ] 🗃️ 87 > [](Days/day87.md)
- [ ] 🗃️ 88 > [](Days/day88.md)
- [ ] 🗃️ 89 > [](Days/day89.md)
- [ ] 🗃️ 90 > [](Days/day90.md)
